orte/mca/pls/pls.h File Reference.TH "orte/mca/pls/pls.h" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
orte/mca/pls/pls.h \- The Open RTE Process Launch Subsystem. 
.SH SYNOPSIS
.br
.PP
\fC#include 'orte_config.h'\fP
.br
\fC#include 'mca/mca.h'\fP
.br
\fC#include 'mca/ns/ns_types.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBORTE_PLS_BASE_VERSION_1_0_0\fP"
.br
.RI "\fIMacro for use in modules that are of type pls v1.0.0. \fP"
.in -1c
.SS "Typedefs"

.in +1c
.ti -1c
.RI "typedef int(* \fBorte_pls_base_module_launch_fn_t\fP )(\fBorte_jobid_t\fP)"
.br
.RI "\fILaunch the indicated jobid. \fP"
.ti -1c
.RI "typedef int(* \fBorte_pls_base_module_terminate_job_fn_t\fP )(\fBorte_jobid_t\fP)"
.br
.RI "\fITerminate any processes launched for the respective jobid by this component. \fP"
.ti -1c
.RI "typedef int(* \fBorte_pls_base_module_terminate_proc_fn_t\fP )(const orte_process_name_t *)"
.br
.RI "\fITerminate a specific process. \fP"
.ti -1c
.RI "typedef int(* \fBorte_pls_base_module_finalize_fn_t\fP )(void)"
.br
.RI "\fICleanup all resources held by the module. \fP"
.ti -1c
.RI "typedef \fBorte_pls_base_module_1_0_0_t\fP \fBorte_pls_base_module_1_0_0_t\fP"
.br
.RI "\fIshorten \fBorte_pls_base_module_1_0_0_t\fP declaration \fP"
.ti -1c
.RI "typedef \fBorte_pls_base_module_1_0_0_t\fP \fBorte_pls_base_module_t\fP"
.br
.RI "\fIshorten orte_pls_base_module_t declaration \fP"
.ti -1c
.RI "typedef \fBorte_pls_base_module_1_0_0_t\fP *(* \fBorte_pls_base_component_init_fn_t\fP )(int *priority)"
.br
.RI "\fIpls initialization function \fP"
.ti -1c
.RI "typedef \fBorte_pls_base_component_1_0_0_t\fP \fBorte_pls_base_component_1_0_0_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.ti -1c
.RI "typedef \fBorte_pls_base_component_1_0_0_t\fP \fBorte_pls_base_component_t\fP"
.br
.RI "\fIConvenience typedef. \fP"
.in -1c
.SH "Detailed Description"
.PP 
The Open RTE Process Launch Subsystem. 

The process launch subsystem (PLS) is responsible for actually launching a specified application's processes across the indicated resource. The PLS is invoked by the controlling program (mpirun or whatever) after the resource discovery, allocation, and mapping subsystems have performed their work. Thus, the PLS can assume that certain data structures have been created, and that some data MAY be present - the PLS must also be capable of appropriately dealing with situations where earlier subsystems may not have access to complete information. For example, while the discovery subsystem (RDS) will provide information on the launcher used by a particular resource, that information may NOT have been provided and hence may not be available when the PLS is invoked. Thus, the PLS components must include the ability to sense their environment where necessary.
.PP
The PLS obtains its input information from several sources:
.PP
.IP "\(bu" 2
the ORTE_JOB_SEGMENT of the registry. Information on this segment includes: the application to be executed; the number of processes of each application to be run; the context (argv and enviro arrays) for each process.
.PP
.PP
.IP "\(bu" 2
the ORTE_RESOURCE_SEGMENT of the registry. This includes: identification of the launcher to be used on the indicated resource; location of temporary directory and other filesystem directory locations;
.PP
.PP
.IP "\(bu" 2
MCA parameters. This includes any directive from the user as to the launcher to be used and/or its configuration.
.PP
.PP
The PLS uses this information to launch the processes upon the indicated resource(s). PLS components are free to ignore information that is not pertinent to their operation. For example, although the user may have specified a particular mapping of process to nodename, a PLS launching the application on a resource that does not permit such specifications would ignore the corresponding information that the mapper placed on the registry - it is irrelevant to that launcher's operation (although a warning to the user, in this case, might be appropriate).
.PP
The PLS is tightly coupled to the PLSNDS - the PLS name discovery service - that each process uses to 'discover' its official name. Each PLS MUST:
.PP
.IP "\(bu" 2
set the MCA parameter 'pls_base_nds' to indicate the which name discoverty service should be used on the remote side to discover the process' name. The contents of the MCA parameter should be one of the string names in the PLSNDS (currently, this is hard-coded in plsnds_open_close.c -- see below -- but someday it will likely turn into another framework/set of components).
.PP
.PP
.IP "\(bu" 2
have a corresponding entry in the orte_plsnds table (defined in src/plsnds/plsnds_open_close.c) that identifies the NDS its associated function for obtaining the process name.
.PP
.PP
.IP "\(bu" 2
where necessary, provide a function in the orte_plsnds directory that can define the process name from whatever info that corresponding launcher provided
.PP
.PP
More information on the requirements for the PLSNDS can be found in the header file src/plsnds/plsnds.h.
.PP
Unless otherwise directed by the user and/or the system configuration, the PLS will utilize a daemon-based launch to maximize the availability of ORTE services. To accomplish this, the resource manager (RMGR) subsystem must support both the detection of daemon existence and the ability to execute a two-step launch sequence (with the first step being daemon launch, followed by the secondary application launch). In turn, the PLS must provide a component with the ability to launch via an existing daemon.
.PP
NOTE: The RMGR may override local launcher specification to utilize the daemon-based launch component - it is expected that the daemons in the local environment will know how to launch in that environment. It is vital, therefore, that the PLS components NOT be directly called by any ORTE function - instead, all PLS functionality is to be accessed via the RMGR.
.PP
As part of the launch procedure, PLS components must provide the following capabilities:
.PP
.IP "\(bu" 2
set the 'pls_base_nds' MCA parameter indicating which NDS is to be used. This information is subsequently used by the name discovery service to determine a process' official name, as described above.
.PP
.PP
.IP "\(bu" 2
setup I/O forwarding for all processes (where possible). Some environments will, of course, not support this capability or will provide it natively. Those respective PLS components should behave accordingly. In other cases, however, the PLS component should establish the I/O forwarding interconnects and enable that subsystem.
.PP
.PP
<jms> Since I/O forwarding is still under develpoment, this is not yet well-defined. </jms>
.PP
.IP "\(bu" 2
pass context info to each process. The argv and enviro arrays are stored on the registry by the resource allocation subsystem (RAS) - this includes any process- specific deviations from the application's general overall context. The PLS should obtain this information from the registry and pass the context along to each process.
.PP
.PP
.IP "\(bu" 2
utilize scalable launch methods (where possible). In environments that allow it, PLS components should utilize methods that support scalable launch of applications involving large numbers of processes.
.PP
.PP
.IP "\(bu" 2
detect that required libraries are present on involved compute nodes. This is a secondary feature for future implementations.
.PP
.PP
.IP "\(bu" 2
preposition files and libraries where required and possible. This is a secondary feature for future implementations.
.PP
.PP
When launching an application, the PLS shall update the registry with information on batch jobid, assigned jobname, etc. that may have been provided by the local resource's launcher. This information is stored on the registry's ORTE_JOB_SEGMENT in the 'global' container. In addition, any information relevant to state-of-health monitoring (e.g., sockets opened to an application process by a spawning daemon to detect completion of process startup) should be stored on the ORTE_JOB_SEGMENT in the respective process' container.
.PP
Once a process is launched, two options exist for subsequent operations:
.PP
.IP "\(bu" 2
if it is an ORTE process (i.e., one that calls orte_init), the process will register itself on the ORTE_JOB_SEGMENT of the registry. This includes providing information on the nodename where the process is located, contact information for the runtime message library (RML) and other subsystems, local pid, etc.
.PP
.PP
.IP "\(bu" 2
if it is NOT an ORTE process, then registration will not take place. In this case, the ability to subsequently monitor the progress/state-of-health of the process and/or provide other services *may* be limited. The PLS has no further responsibilities for such processes.
.PP
.PP
Once the PLS has completed launch of the application, it notifies the state-of-health (SOH) monitor that a jobid has been launched and is now available for monitoring. It is the SOH's responsibility to determine the level of monitoring that can be provided, and to notify the rest of the ORTE system of process failures/problems.
.PP
<jms> Still to be defined:
.PP
.IP "\(bu" 2
Need to add a 'kill process' module API function
.PP
.PP
.IP "\(bu" 2
If a PLS fails during a job launch, it should call the errmanager which will tell it what to do (abort, kill all those already launched and abort, continue, etc.). </jms>
.PP

.SH "Define Documentation"
.PP 
.SS "#define ORTE_PLS_BASE_VERSION_1_0_0"
.PP
\fBValue:\fP
.PP
.nf
/* pls v1.0 is chained to MCA v1.0 */ \
  MCA_BASE_VERSION_1_0_0, \
  /* pls v1.0 */ \
  'pls', 1, 0, 0
.fi
Macro for use in modules that are of type pls v1.0.0. 
.PP
.SH "Typedef Documentation"
.PP 
.SS "typedef struct \fBorte_pls_base_module_1_0_0_t\fP*(* \fBorte_pls_base_component_init_fn_t\fP)(int *priority)"
.PP
pls initialization function 
.PP
Called by the MCA framework to initialize the component. Invoked exactly once per process.
.PP
\fBParameters:\fP
.RS 4
\fIpriority\fP (OUT) Relative priority or ranking use by MCA to select a module. 
.RE
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
